unit DD68u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TDD68f1 = class(TForm)
    ScrollBar1: TScrollBar;
    Timer1: TTimer;
    buQuit: TButton;
    buAckWarn: TButton;
    buAckAlarm: TButton;
    Memo1: TMemo;
    procedure Timer1Timer(Sender: TObject);
    procedure buQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure buAckWarnClick(Sender: TObject);
    procedure buAckAlarmClick(Sender: TObject);

  private
    { Private declarations }
    iNumWarnings,iNumAlarms:integer;
    boWarningAckd, boAlarmAckd:boolean;
    procedure CheckAndHandleAlarmsOrWarnings;
    procedure ReactToWarning(sMsg:string);
    procedure ReactToAlarm(sMsg:string);
    procedure WriteToMemo(var meWhichMemo:TMemo;sMsg:string);
    procedure Flash(var meWhich:Tmemo;cl1,cl2:Tcolor);
    procedure MakeNormal(var meWhich:Tmemo);

  public
    { Public declarations }
  end;

var
  DD68f1: TDD68f1;

implementation

uses DD68uWarnings, DD68uAlarms;

{$R *.DFM}

procedure TDD68f1.Timer1Timer(Sender: TObject);
begin
CheckAndHandleAlarmsOrWarnings;
end;

procedure TDD68f1.buQuitClick(Sender: TObject);
begin
application.terminate;
end;

procedure TDD68f1.CheckAndHandleAlarmsOrWarnings;
begin
if scrollbar1.position>60 then ReactToAlarm('Scrollbar Position');
if scrollbar1.position>30 then ReactToWarning('Scrollbar Position');

if boWarningAckd=false then Flash(DD68FWarnings.memo1,clBlue,clYellow);
if boAlarmAckd=false then Flash(DD68FAlarms.memo1,clRed,clWindow);

end;

procedure TDD68f1.ReactToWarning(sMsg:string);
begin
       boWarningAckd:=false;
       scrollbar1.position:=0;
       inc(iNumWarnings);
       WriteToMemo(DD68fWarnings.memo1,
                inttostr(iNumWarnings)+
                ': Warning seen at '+
                DateTimeToStr(now)+
                ' '+sMsg);
end;

procedure TDD68f1.ReactToAlarm(sMsg:string);
begin
       boAlarmAckd:=false;
       scrollbar1.position:=0;
       inc(iNumAlarms);
       WriteToMemo(DD68fAlarms.memo1,
                inttostr(iNumAlarms)+
                ': Alarm seen at '+
                DateTimeToStr(now)+
                ' '+sMsg);
end;

procedure TDD68f1.FormCreate(Sender: TObject);
begin
iNumWarnings:=0;
iNumAlarms:=0;
boWarningAckd:=true;
boAlarmAckd:=true;
end;

procedure TDD68f1.WriteToMemo(var meWhichMemo:TMemo;sMsg:string);
begin
meWhichMemo.lines.add(sMsg);
//if meWhichMemo=DD68fWarnings.memo1 then writeln(dfWarnings(sMsg));
//if meWhichMemo=DD68fAlarms.memo1 then writeln(dfWarnings(sMsg));
end;

procedure TDD68f1.buAckWarnClick(Sender: TObject);
begin
boWarningAckd:=true;
MakeNormal(DD68fWarnings.memo1);
end;

procedure TDD68f1.buAckAlarmClick(Sender: TObject);
begin
boAlarmAckd:=true;
MakeNormal(DD68fAlarms.memo1);
end;

procedure TDD68f1.Flash(var meWhich:Tmemo;cl1,cl2:Tcolor);
begin
if meWhich.color=cl1 then begin
   meWhich.color:=cl2;
   meWhich.font.color:=cl1
   end// no ; here
 else begin
   meWhich.color:=cl1;
   meWhich.font.color:=cl2
   end;//else
end;

procedure TDD68f1.MakeNormal(var meWhich:Tmemo);
begin
   meWhich.font.color:=clBlack;
   meWhich.color:=clWindow;//clWindow will make the background
       //be whatever color the user has selected for window backgrounds
       //across all his/her desktop.
end;


end.
